;Some COUT related functions

STDIN  equ 0
STDOUT equ 1
STDERR equ 2

.386p
include pmc.inc

extrn _lowbase:dword

public L_StrLen
public L_ConvToStr
public L_WriteEAX
public L_WriteStr
public L_DoCR


_TEXTseg

PROC L_StrLen NEAR
; Pointer to ASCIIZ string in EDX
; returns number of chars in ECX
; EDX is not changed
        xor     ecx, ecx
        push    eax
lab2:   mov     al, [edx+ecx]
        cmp     al, 0
        je      lab1
        inc     ecx
        jmp     lab2
lab1:   pop     eax
        ret
ENDP L_StrLen


PROC L_ConvToStr NEAR
; Converts any number to a string
; Input: eax : value to convert to ASCII
;        ecx : number system 2 - 16
; Output:
;        edx : pointer to string
;----------------------------------------------------------------------------
        lea     ebx, [numberbuf + 33]
        mov     byte ptr [ebx], 0
        xor     esi, esi
        
        cmp     eax, 0
        jns     lab8   ;signed?
        mov     esi, 1
        neg     eax
lab8:   xor     edx,edx
        div     ecx
        dec     ebx
        mov     dl,[numbertable+edx]
        mov     [ebx],dl
        test    eax,eax
        jnz     lab8

        cmp     esi, 0
        je      lab7
        dec     ebx
        mov     byte ptr [ebx], '-'
lab7:   mov     edx, ebx
        ret
ENDP L_ConvToStr


PROC L_WriteEAX NEAR
        mov     ecx, numbersys
        call    L_ConvToStr
        call    L_WriteStr
        ret
ENDP L_WriteEAX


PROC L_WriteStr NEAR
;Pointer to pascal-string in EDX

        call    L_StrLen
        ;ecx = strlen
        ;edx = pointer to begin of string

        mov     eax, edx            ; get offset of message in protected mode
        add     eax, _lowbase       ; adjust to an absolute address
        
        mov     ebx, eax
        shr     ebx, 4
        and     eax, 0fh
                                
        mov     rs.rsCX, cx
        mov     rs.rsDS, bx         ; put segment into virtual reg for real mode
        mov     rs.rsDX, ax         ; put offset into virtual reg for real mode
        mov     rs.rsBX, 1          ; STDOUT
        mov     rs.rsAH, 040h       ; Write to a File or Device
        mov     rs.rsSS, 0
        mov     rs.rsSP, 0

        push    ds
        pop     es
        xor     ecx, ecx
        mov     edi, offset rs
        mov     ebx, 021h
        mov     eax, 0300h
        int     031h                ; Simulate real mode INT

        ret
ENDP L_WriteStr


PROC L_DoCR NEAR
        mov     eax, offset messageCR
        add     eax, _lowbase       ; adjust to an absolute address
        
        mov     ebx, eax
        shr     ebx, 4
        and     eax, 0fh
             
        mov     rs.rsCX, 2
        mov     rs.rsDS, bx         ; put segment into virtual reg for real mode
        mov     rs.rsDX, ax         ; put offset into virtual reg for real mode
        mov     rs.rsBX, 1          ; STDOUT
        mov     rs.rsAH, 040h       ; Write to a File or Device
        mov     rs.rsSS, 0
        mov     rs.rsSP, 0
                           
        push    ds
        pop     es
        xor     ecx, ecx
        mov     edi, offset rs
        mov     ebx, 021h
        mov     eax, 0300h
        int     031h                ; Simulate real mode INT

        ret
ENDP L_DoCR

;
;PROC L_strcpy NEAR
;        push    ebp
;        mov     ebp,esp
;        push    eax ebx edx
;        mov     ebx, dword ptr [ebp+8+1*4]
;        mov     edx, dword ptr [ebp+8+0*4]
;lab3:   mov     al, [edx]
;        cmp     al, 0
;        je      lab4
;        mov     [ebx], al
;        inc     ebx
;        inc     edx
;        jmp     lab3
;lab4:   mov     [ebx], al
;        pop     edx ebx eax
;        pop     ebp
;        retn    8
;ENDP L_strcpy
;
ends


_DATAseg

rs REGSTRUCT <>

messageCR db 0ah,0dh
numbertable db '0123456789ABCDEF'
numberbuf db 34 DUP(0)
numbersys dd 10

ends
end
